#!/usr/bin/python
#-*-coding: cp949 -*-

from cartoonFetcher import *

class StooFetcher(CartoonFetcher):
    def __init__(self):
        self.currentCartoonNumber = 0
        self.lastestCartoonNumber = 0
        
        self.digitsList = list( string.digits )
        
        self.baseUrl = 'http://cartoon.stoo.com/'
        
        #ȭ ڷᰡ ִ 
        #key : ȭ ̸
        #value[0] : ȸ ѱ̸
        #value[1] : ȭ ִ url
        #value[2] : ȭ  Ǿִ° 
        self.cartoonDict = {'choriing':['򸮴', 2, 'http://cartoon.stoo.com/choriing/html/choriing%d.html'],
             'newslisk':['ũ', 1, 'http://cartoon.stoo.com/newslisk/html/newslisk%d.html']}
            
        
    def getCartoonBaseUrl(self, cartoon):
        s = self.baseUrl + cartoon + '/html'
        self.cartoonBaseUrl = s
    
    def getLastestCartoonNumber(self, cartoon, cartoonBaseUrl):
        s = urllib.urlopen(cartoonBaseUrl).read()
        htmlDataList = s.splitlines()
        
        lastestCartoonData = ''         
        
        prevImageUrl = 'http://cartoon.stoo.com/images/btn_preview.gif'
        
        for line in htmlDataList:
            if prevImageUrl in line:
                initPos = line.find('<') + 8
                lastPos = line.find('>')
                prevUrl = line[initPos:lastPos]
                
        count = 0
        self.numberFound = False
        for char in prevUrl:
            if self.numberFound == False:
                if char in self.digitsList:
                    initPos = count
                    self.numberFound = True
                    continue
                
            elif self.numberFound == True:
                if char not in self.digitsList:
                    lastPos = count + 1
                    break
                
            count = count + 1
        
        self.lastestCartoonNumber = int( prevUrl[initPos:lastPos] ) + 1
        return self.lastestCartoonNumber 
        
    def fetchCartoon(self, cartoon, number):
        url = self.cartoonDict[cartoon][2] % (number, )
        #number cartoon ִ html ּ
        s = urllib.urlopen(url).read()
        htmlDataList = s.splitlines()
        
        self.cartoon1Url = ''
        self.cartoon2Url = ''
        
        self.htmlReadContinue = False
        
        for line in htmlDataList:
            if '''<!--// ȭ  ̹ -->''' in line:
                self.htmlReadContinue = True
            
            elif self.htmlReadContinue == True:
                if '''<img src=''' in line:
                    temp = line.split("""'""")
                    temp = temp[1]
                    self.cartoon1Url = temp
                    if self.cartoonDict[cartoon][1] == 2:
                        cartoonCountIndex = temp.rfind('1')
                        self.cartoon2Url = temp[:cartoonCountIndex] + '2' + temp[cartoonCountIndex + 1:]
                    break
        print self.cartoon1Url
        print self.cartoon2Url